#include <Arduino.h>
#include <WiFi.h>              
#include "WebSocketsClient.h"
#include <ArduinoJson.h> 
#include <Ticker.h> 


// JOYSTICK CLIENT



//WiFi credentials
const char* ssid = "Device-Northwestern";
const char* password = "";
//const char* ssid = "DOMEK";
//const char* password = "Snowy123!";
WebSocketsClient webSocketMAN;


//Make websocket client and json files
//sendTXT can only send in strings, not JSONS, to the server.
String send;   
StaticJsonDocument<100> json_read;
StaticJsonDocument<100> json_send;

// Pot pins
#define MAN_ID 2                 // ID of client. I defined this...
#define x_1 36 
#define y_1 39
#define x_2 34
#define y_2 35

#define indicator 33

int reading_x1;
int reading_y1;
int reading_x2;
int reading_y2;

//Setup Timer
Ticker timer;
bool read_data = false;
int state_read;
bool done_with_old = true;


//
//IN INITIAL TEST: NOTING IS SENT TO WEBSOCKET, INFORMATION IS ONLY SENT FROM IT...
//

// Only runs if triggered from the outside: there is some event from the outside which triggers 
// the websocketEvent to run.
void webSocketEvent(WStype_t type, uint8_t * payload, size_t length) {
  if (type == WStype_TEXT)
  {
    DeserializationError error = deserializeJson(json_read, payload); 
    if (error) 
    { 
      Serial.print(F("deserializeJson() failed: "));
      Serial.println(error.c_str());
      return;
    } 
    state_read = json_read["MAN_ON"];
  }
}


void readData() {
  Serial.println("got here");
  if(state_read && done_with_old)
  { 
     done_with_old = false;
     reading_x1 = analogRead(x_1);
     reading_x2 = analogRead(x_2);
     reading_y1 = analogRead(y_1);
     reading_y2 = analogRead(y_2);

    send = "{\"ID\":";
    send += MAN_ID;
    send += ",\"POT_X1\":";
    send += reading_x1;
    send += ",\"POT_X2\":";
    send += reading_x2;
    send += ",\"POT_Y1\":";
    send += reading_y1;
    send += ",\"POT_Y2\":";
    send += reading_y2;
    send += "}";

    Serial.println(reading_x1);
    webSocketMAN.sendTXT(send.c_str(),send.length()); 
    done_with_old = true;  
  }
}

void setup() 
{
  Serial.begin(115200);
  //setup ticker
  timer.attach_ms(/*rate in secs*/ 25, /*callback*/ readData);

  WiFi.begin(ssid);
  while (WiFi.status() != WL_CONNECTED) 
  {
    Serial.print(".");
    delay(500);
  }
    // Check if connected to wifi
  if(WiFi.status() != WL_CONNECTED) {
    Serial.println("No Wifi!");
    return;
  }
  Serial.println();
  Serial.print("IP Address (AP): "); Serial.println(WiFi.localIP());

 //webSocketEMG.begin("192.168.1.110", 81,"/emg","arduino");   //HOME
 //webSocketMAN.begin("10.106.9.60", 81,"/manual","arduino");     //SCHOOL
 //webSocketMAN.begin("192.168.4.1", 81,"/manual","arduino");
 //webSocketMAN.begin("10.105.112.17", 81,"/manual","arduino");
 // webSocketMAN.begin("10.106.9.60", 81,"/manual","arduino");  last safe reset
//webSocketMAN.begin("10.106.7.5", 81,"/manual","arduino"); // local ip?


 webSocketMAN.begin("10.106.7.5", 81,"/manual","arduino"); // local ip?
 webSocketMAN.onEvent(webSocketEvent);
 webSocketMAN.setReconnectInterval(5000);
}

void loop() 
{
  webSocketMAN.loop(); 
}

